using System;
using System.Speech.Recognition;
using System.Globalization;
using System.Windows.Forms;

namespace NingTao
{
  public class SRecognition
  {
    public SpeechRecognitionEngine recognizer = null;//ʶ  
    public DictationGrammar dictationGrammar = null; //Ȼ﷨  
    public System.Windows.Forms.Control cDisplay; //ʾؼ  

    public SRecognition(string[] fg) //ؼб  
    {
      CultureInfo myCIintl = new CultureInfo("zh-CN");
      foreach (RecognizerInfo config in SpeechRecognitionEngine.InstalledRecognizers())//ȡ  
      {
        if (config.Culture.Equals(myCIintl) && config.Id == "MS-2052-80-DESK")
        {
          recognizer = new SpeechRecognitionEngine(config);
          break;
        }//ѡʶ
      }
      if (recognizer != null)
      {
        InitializeSpeechRecognitionEngine(fg);//ʼʶ  
        dictationGrammar = new DictationGrammar();
      }
      else
      {
        MessageBox.Show("ʶʧ");
      }
    }
    private void InitializeSpeechRecognitionEngine(string[] fg)
    {
      recognizer.SetInputToDefaultAudioDevice();//ѡĬϵƵ豸  
      Grammar customGrammar = CreateCustomGrammar(fg);
      //ݹؼ齨﷨  
      recognizer.UnloadAllGrammars();
      recognizer.LoadGrammar(customGrammar);
      //﷨  
      recognizer.SpeechRecognized += new EventHandler<SpeechRecognizedEventArgs>(recognizer_SpeechRecognized);
      //recognizer.SpeechHypothesized += new EventHandler <SpeechHypothesizedEventArgs>(recognizer_SpeechHypothesized);  
    }
    public void BeginRec(Control tbResult)//ڿؼ  
    {
      TurnSpeechRecognitionOn();
      TurnDictationOn();
      cDisplay = tbResult;
    }
    public void over()//ֹͣʶ  
    {
      TurnSpeechRecognitionOff();
    }
    public virtual Grammar CreateCustomGrammar(string[] fg) //Զ﷨  
    {
      GrammarBuilder grammarBuilder = new GrammarBuilder();
      grammarBuilder.Append(new Choices(fg));
      return new Grammar(grammarBuilder);
    }
    private void TurnSpeechRecognitionOn()//ʶ  
    {
      if (recognizer != null)
      {
        recognizer.RecognizeAsync(RecognizeMode.Multiple);
        //ʶģʽΪʶ  
      }
      else
      {
        MessageBox.Show("ʶʧ");
      }
    }
    private void TurnSpeechRecognitionOff()//رʶ  
    {
      if (recognizer != null)
      {
        recognizer.RecognizeAsyncStop();
        TurnDictationOff();
      }
      else
      {
        MessageBox.Show("ʶʧ");
      }
    }
    private void recognizer_SpeechRecognized(object sender, SpeechRecognizedEventArgs e)
    {
      //ʶɵĶͨʶĳһؼ  
      string text = e.Result.Text;
      cDisplay.Text += text;
    }
    private void TurnDictationOn()
    {
      if (recognizer != null)
      {
        recognizer.LoadGrammar(dictationGrammar);
        //Ȼ﷨  
      }
      else
      {
        MessageBox.Show("ʶʧ");
      }
    }
    private void TurnDictationOff()
    {
      if (dictationGrammar != null)
      {
        recognizer.UnloadGrammar(dictationGrammar);
        //жȻ﷨  
      }
      else
      {
        MessageBox.Show("ʶʧ");
      }
    }
  }
}